diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_purp.c openssl-1.0.0q/crypto/x509v3/v3_purp.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_purp.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_purp.c	2017-04-25 16:23:40.887798865 +0200
@@ -56,10 +56,13 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/x509v3.h>
 #include <openssl/x509_vfy.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static void x509v3_cache_extensions(X509 *x);
 
@@ -73,29 +76,46 @@
 static int check_purpose_crl_sign(const X509_PURPOSE *xp, const X509 *x, int ca);
 static int check_purpose_timestamp_sign(const X509_PURPOSE *xp, const X509 *x, int ca);
 static int no_check(const X509_PURPOSE *xp, const X509 *x, int ca);
+#ifndef OPENSSL_NO_OCSP
 static int ocsp_helper(const X509_PURPOSE *xp, const X509 *x, int ca);
+#endif
 
 static int xp_cmp(const X509_PURPOSE * const *a,
 		const X509_PURPOSE * const *b);
 static void xptable_free(X509_PURPOSE *p);
 
-static X509_PURPOSE xstandard[] = {
-	{X509_PURPOSE_SSL_CLIENT, X509_TRUST_SSL_CLIENT, 0, check_purpose_ssl_client, "SSL client", "sslclient", NULL},
-	{X509_PURPOSE_SSL_SERVER, X509_TRUST_SSL_SERVER, 0, check_purpose_ssl_server, "SSL server", "sslserver", NULL},
-	{X509_PURPOSE_NS_SSL_SERVER, X509_TRUST_SSL_SERVER, 0, check_purpose_ns_ssl_server, "Netscape SSL server", "nssslserver", NULL},
-	{X509_PURPOSE_SMIME_SIGN, X509_TRUST_EMAIL, 0, check_purpose_smime_sign, "S/MIME signing", "smimesign", NULL},
-	{X509_PURPOSE_SMIME_ENCRYPT, X509_TRUST_EMAIL, 0, check_purpose_smime_encrypt, "S/MIME encryption", "smimeencrypt", NULL},
-	{X509_PURPOSE_CRL_SIGN, X509_TRUST_COMPAT, 0, check_purpose_crl_sign, "CRL signing", "crlsign", NULL},
-	{X509_PURPOSE_ANY, X509_TRUST_DEFAULT, 0, no_check, "Any Purpose", "any", NULL},
-	{X509_PURPOSE_OCSP_HELPER, X509_TRUST_COMPAT, 0, ocsp_helper, "OCSP helper", "ocsphelper", NULL},
-	{X509_PURPOSE_TIMESTAMP_SIGN, X509_TRUST_TSA, 0, check_purpose_timestamp_sign, "Time Stamp signing", "timestampsign", NULL},
-};
+#define CONST_X509_PURPOSE_ENTRY(purp, trst, _flags, ch_purp, _lname, _sname, _usr_data) \
+	CONST_ENTRY_START(purpose,purp)\
+	CONST_ENTRY_SINGLE(trust,trst)\
+	CONST_ENTRY_SINGLE(flags,_flags)\
+	CONST_ENTRY_SINGLE(check_purpose,ch_purp)\
+	CONST_ENTRY_SINGLE(name,_lname)\
+	CONST_ENTRY_SINGLE(sname,_sname)\
+	CONST_ENTRY_SINGLE(usr_data,_usr_data)\
+	CONST_ENTRY_END
+
+OPENSSL_PREFIX_CONST_ARRAY(static, X509_PURPOSE, xstandard, libopeay)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_SSL_CLIENT, X509_TRUST_SSL_CLIENT, 0, check_purpose_ssl_client, "SSL client", "sslclient", NULL)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_SSL_SERVER, X509_TRUST_SSL_SERVER, 0, check_purpose_ssl_server, "SSL server", "sslserver", NULL)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_NS_SSL_SERVER, X509_TRUST_SSL_SERVER, 0, check_purpose_ns_ssl_server, "Netscape SSL server", "nssslserver", NULL)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_SMIME_SIGN, X509_TRUST_EMAIL, 0, check_purpose_smime_sign, "S/MIME signing", "smimesign", NULL)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_SMIME_ENCRYPT, X509_TRUST_EMAIL, 0, check_purpose_smime_encrypt, "S/MIME encryption", "smimeencrypt", NULL)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_CRL_SIGN, X509_TRUST_COMPAT, 0, check_purpose_crl_sign, "CRL signing", "crlsign", NULL)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_ANY, X509_TRUST_DEFAULT, 0, no_check, "Any Purpose", "any", NULL)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_OCSP_HELPER, X509_TRUST_COMPAT, 0, ocsp_helper, "OCSP helper", "ocsphelper", NULL)
+	CONST_X509_PURPOSE_ENTRY(X509_PURPOSE_TIMESTAMP_SIGN, X509_TRUST_TSA, 0, check_purpose_timestamp_sign, "Time Stamp signing", "timestampsign", NULL)
+CONST_END(xstandard)
 
-#define X509_PURPOSE_COUNT (sizeof(xstandard)/sizeof(X509_PURPOSE))
+#define X509_PURPOSE_COUNT OPENSSL_CONST_ARRAY_SIZE(xstandard)
 
 IMPLEMENT_STACK_OF(X509_PURPOSE)
 
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(STACK_OF(X509_PURPOSE) *, xptable);
+#define xptable OPENSSL_GLOBAL_REF(xptable)
+#else
 static STACK_OF(X509_PURPOSE) *xptable = NULL;
+#endif
 
 static int xp_cmp(const X509_PURPOSE * const *a,
 		const X509_PURPOSE * const *b)
@@ -132,6 +152,7 @@
 	return 1;
 }
 
+
 int X509_PURPOSE_get_count(void)
 {
 	if(!xptable) return X509_PURPOSE_COUNT;
@@ -141,17 +162,18 @@
 X509_PURPOSE * X509_PURPOSE_get0(int idx)
 {
 	if(idx < 0) return NULL;
-	if(idx < (int)X509_PURPOSE_COUNT) return xstandard + idx;
+	if(idx < (int) X509_PURPOSE_COUNT) return (X509_PURPOSE *)OPENSSL_GLOBAL_ARRAY_NAME(xstandard) + idx;
 	return sk_X509_PURPOSE_value(xptable, idx - X509_PURPOSE_COUNT);
 }
 
+
 int X509_PURPOSE_get_by_sname(char *sname)
 {
 	int i;
-	X509_PURPOSE *xptmp;
+	const X509_PURPOSE *xptmp;
 	for(i = 0; i < X509_PURPOSE_get_count(); i++) {
 		xptmp = X509_PURPOSE_get0(i);
-		if(!strcmp(xptmp->sname, sname)) return i;
+		if(!op_strcmp(xptmp->sname, sname)) return i;
 	}
 	return -1;
 }
@@ -171,10 +193,10 @@
 
 int X509_PURPOSE_add(int id, int trust, int flags,
 			int (*ck)(const X509_PURPOSE *, const X509 *, int),
-					char *name, char *sname, void *arg)
+					const char *name, const char *sname, void *arg)
 {
 	int idx;
-	X509_PURPOSE *ptmp;
+	X509_PURPOSE *ptmp, *ptmp_alloc = NULL;
 	/* This is set according to what we change: application can't set it */
 	flags &= ~X509_PURPOSE_DYNAMIC;
 	/* This will always be set for application modified trust entries */
@@ -183,23 +205,29 @@
 	idx = X509_PURPOSE_get_by_id(id);
 	/* Need a new entry */
 	if(idx == -1) {
-		if(!(ptmp = OPENSSL_malloc(sizeof(X509_PURPOSE)))) {
+		if(!(ptmp_alloc = ptmp = (X509_PURPOSE *) OPENSSL_malloc(sizeof(X509_PURPOSE)))) {
 			X509V3err(X509V3_F_X509_PURPOSE_ADD,ERR_R_MALLOC_FAILURE);
 			return 0;
 		}
 		ptmp->flags = X509_PURPOSE_DYNAMIC;
-	} else ptmp = X509_PURPOSE_get0(idx);
+	} else ptmp = (X509_PURPOSE *) X509_PURPOSE_get0(idx);
 
 	/* OPENSSL_free existing name if dynamic */
 	if(ptmp->flags & X509_PURPOSE_DYNAMIC_NAME) {
-		OPENSSL_free(ptmp->name);
-		OPENSSL_free(ptmp->sname);
+		OPENSSL_free((char *) ptmp->name); /* Conversion of pointer to allocated memory */
+		OPENSSL_free((char *) ptmp->sname); /* Conversion of pointer to allocated memory */
 	}
 	/* dup supplied name */
 	ptmp->name = BUF_strdup(name);
 	ptmp->sname = BUF_strdup(sname);
 	if(!ptmp->name || !ptmp->sname) {
 		X509V3err(X509V3_F_X509_PURPOSE_ADD,ERR_R_MALLOC_FAILURE);
+		if(ptmp_alloc)
+		{
+			OPENSSL_free((char *) ptmp->name);
+			OPENSSL_free((char *) ptmp->sname);
+			OPENSSL_free(ptmp_alloc);
+		}
 		return 0;
 	}
 	/* Keep the dynamic flag of existing entry */
@@ -216,10 +244,22 @@
 	if(idx == -1) {
 		if(!xptable && !(xptable = sk_X509_PURPOSE_new(xp_cmp))) {
 			X509V3err(X509V3_F_X509_PURPOSE_ADD,ERR_R_MALLOC_FAILURE);
+			if(ptmp_alloc)
+			{
+				OPENSSL_free((char *) ptmp->name);
+				OPENSSL_free((char *) ptmp->sname);
+				OPENSSL_free(ptmp_alloc);
+			}
 			return 0;
 		}
 		if (!sk_X509_PURPOSE_push(xptable, ptmp)) {
 			X509V3err(X509V3_F_X509_PURPOSE_ADD,ERR_R_MALLOC_FAILURE);
+			if(ptmp_alloc)
+			{
+				OPENSSL_free((char *) ptmp->name);
+				OPENSSL_free((char *) ptmp->sname);
+				OPENSSL_free(ptmp_alloc);
+			}
 			return 0;
 		}
 	}
@@ -232,8 +272,8 @@
 	if (p->flags & X509_PURPOSE_DYNAMIC) 
 		{
 		if (p->flags & X509_PURPOSE_DYNAMIC_NAME) {
-			OPENSSL_free(p->name);
-			OPENSSL_free(p->sname);
+			OPENSSL_free((char *) p->name);/* Conversion of pointer to allocated memory */
+			OPENSSL_free((char *) p->sname);/* Conversion of pointer to allocated memory */
 		}
 		OPENSSL_free(p);
 		}
@@ -243,10 +283,11 @@
 {
 	unsigned int i;
 	sk_X509_PURPOSE_pop_free(xptable, xptable_free);
-	for(i = 0; i < X509_PURPOSE_COUNT; i++) xptable_free(xstandard + i);
+	for(i = 0; i < (unsigned int) X509_PURPOSE_COUNT; i++) xptable_free((X509_PURPOSE *) OPENSSL_GLOBAL_ARRAY_NAME(xstandard) + i);
 	xptable = NULL;
 }
 
+#ifndef OPERA_SMALL_VERSION
 int X509_PURPOSE_get_id(X509_PURPOSE *xp)
 {
 	return xp->purpose;
@@ -266,6 +307,7 @@
 {
 	return xp->trust;
 }
+#endif // !OPERA_SMALL_VERSION
 
 static int nid_cmp(const int *a, const int *b)
 	{
@@ -349,7 +391,7 @@
 static void setup_crldp(X509 *x)
 	{
 	int i;
-	x->crldp = X509_get_ext_d2i(x, NID_crl_distribution_points, NULL, NULL);
+	x->crldp = (STACK_OF(DIST_POINT) *)X509_get_ext_d2i(x, NID_crl_distribution_points, NULL, NULL);
 	for (i = 0; i < sk_DIST_POINT_num(x->crldp); i++)
 		setup_dp(x, sk_DIST_POINT_value(x->crldp, i));
 	}
@@ -374,7 +416,7 @@
 	/* V1 should mean no extensions ... */
 	if(!X509_get_version(x)) x->ex_flags |= EXFLAG_V1;
 	/* Handle basic constraints */
-	if((bs=X509_get_ext_d2i(x, NID_basic_constraints, NULL, NULL))) {
+	if((bs= (BASIC_CONSTRAINTS *) X509_get_ext_d2i(x, NID_basic_constraints, NULL, NULL))) {
 		if(bs->ca) x->ex_flags |= EXFLAG_CA;
 		if(bs->pathlen) {
 			if((bs->pathlen->type == V_ASN1_NEG_INTEGER)
@@ -387,7 +429,7 @@
 		x->ex_flags |= EXFLAG_BCONS;
 	}
 	/* Handle proxy certificates */
-	if((pci=X509_get_ext_d2i(x, NID_proxyCertInfo, NULL, NULL))) {
+	if((pci= (PROXY_CERT_INFO_EXTENSION *) X509_get_ext_d2i(x, NID_proxyCertInfo, NULL, NULL))) {
 		if (x->ex_flags & EXFLAG_CA
 		    || X509_get_ext_by_NID(x, NID_subject_alt_name, -1) >= 0
 		    || X509_get_ext_by_NID(x, NID_issuer_alt_name, -1) >= 0) {
@@ -401,7 +443,7 @@
 		x->ex_flags |= EXFLAG_PROXY;
 	}
 	/* Handle key usage */
-	if((usage=X509_get_ext_d2i(x, NID_key_usage, NULL, NULL))) {
+	if((usage=(ASN1_OCTET_STRING *) X509_get_ext_d2i(x, NID_key_usage, NULL, NULL))) {
 		if(usage->length > 0) {
 			x->ex_kusage = usage->data[0];
 			if(usage->length > 1) 
@@ -411,7 +453,7 @@
 		ASN1_BIT_STRING_free(usage);
 	}
 	x->ex_xkusage = 0;
-	if((extusage=X509_get_ext_d2i(x, NID_ext_key_usage, NULL, NULL))) {
+	if((extusage= (EXTENDED_KEY_USAGE *) X509_get_ext_d2i(x, NID_ext_key_usage, NULL, NULL))) {
 		x->ex_flags |= EXFLAG_XKUSAGE;
 		for(i = 0; i < sk_ASN1_OBJECT_num(extusage); i++) {
 			switch(OBJ_obj2nid(sk_ASN1_OBJECT_value(extusage,i))) {
@@ -452,16 +494,16 @@
 		sk_ASN1_OBJECT_pop_free(extusage, ASN1_OBJECT_free);
 	}
 
-	if((ns=X509_get_ext_d2i(x, NID_netscape_cert_type, NULL, NULL))) {
+	if((ns=(ASN1_OCTET_STRING *) X509_get_ext_d2i(x, NID_netscape_cert_type, NULL, NULL))) {
 		if(ns->length > 0) x->ex_nscert = ns->data[0];
 		else x->ex_nscert = 0;
 		x->ex_flags |= EXFLAG_NSCERT;
 		ASN1_BIT_STRING_free(ns);
 	}
-	x->skid =X509_get_ext_d2i(x, NID_subject_key_identifier, NULL, NULL);
-	x->akid =X509_get_ext_d2i(x, NID_authority_key_identifier, NULL, NULL);
-	x->altname = X509_get_ext_d2i(x, NID_subject_alt_name, NULL, NULL);
-	x->nc = X509_get_ext_d2i(x, NID_name_constraints, &i, NULL);
+	x->skid = (ASN1_OCTET_STRING *)X509_get_ext_d2i(x, NID_subject_key_identifier, NULL, NULL);
+	x->akid = (AUTHORITY_KEYID *)X509_get_ext_d2i(x, NID_authority_key_identifier, NULL, NULL);
+	x->altname = (STACK_OF(GENERAL_NAME) *)X509_get_ext_d2i(x, NID_subject_alt_name, NULL, NULL);
+	x->nc = (NAME_CONSTRAINTS *)X509_get_ext_d2i(x, NID_name_constraints, &i, NULL);
 	if (!x->nc && (i != -1))
 		x->ex_flags |= EXFLAG_INVALID;
 	setup_crldp(x);
@@ -505,7 +547,7 @@
 #define ns_reject(x, usage) \
 	(((x)->ex_flags & EXFLAG_NSCERT) && !((x)->ex_nscert & (usage)))
 
-static int check_ca(const X509 *x)
+/*static*/ int check_ca(const X509 *x)
 {
 	/* keyUsage if present should allow cert signing */
 	if(ku_reject(x, KU_KEY_CERT_SIGN)) return 0;
@@ -633,6 +675,7 @@
 	return 1;
 }
 
+#ifndef OPENSSL_NO_OCSP
 /* OCSP helper: this is *not* a full OCSP check. It just checks that
  * each CA is valid. Additional checks must be made on the chain.
  */
@@ -680,6 +723,7 @@
 
 	return 1;
 }
+#endif
 
 static int no_check(const X509_PURPOSE *xp, const X509 *x, int ca)
 {
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_skey.c openssl-1.0.0q/crypto/x509v3/v3_skey.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_skey.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_skey.c	2017-04-25 16:23:40.887798865 +0200
@@ -57,18 +57,24 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+#ifndef OPERA_SMALL_VERSION
 static ASN1_OCTET_STRING *s2i_skey_id(X509V3_EXT_METHOD *method, X509V3_CTX *ctx, char *str);
-const X509V3_EXT_METHOD v3_skey_id = { 
+#endif
+
+CONST_X509V3_EXT_METHOD_item(v3_skey_id,
 NID_subject_key_identifier, 0, ASN1_ITEM_ref(ASN1_OCTET_STRING),
 0,0,0,0,
 (X509V3_EXT_I2S)i2s_ASN1_OCTET_STRING,
-(X509V3_EXT_S2I)s2i_skey_id,
+OPERA_S2I_DECLARE((X509V3_EXT_S2I)s2i_skey_id),
 0,0,0,0,
-NULL};
+NULL)
 
 char *i2s_ASN1_OCTET_STRING(X509V3_EXT_METHOD *method,
 	     ASN1_OCTET_STRING *oct)
@@ -76,6 +82,7 @@
 	return hex_to_string(oct->data, oct->length);
 }
 
+#ifndef OPERA_SMALL_VERSION
 ASN1_OCTET_STRING *s2i_ASN1_OCTET_STRING(X509V3_EXT_METHOD *method,
 	     X509V3_CTX *ctx, char *str)
 {
@@ -103,10 +110,10 @@
 {
 	ASN1_OCTET_STRING *oct;
 	ASN1_BIT_STRING *pk;
-	unsigned char pkey_dig[EVP_MAX_MD_SIZE];
+	unsigned char pkey_dig[EVP_MAX_MD_SIZE];	/* ARRAY OK 2009-05-25 yngve */
 	unsigned int diglen;
 
-	if(strcmp(str, "hash")) return s2i_ASN1_OCTET_STRING(method, ctx, str);
+	if(op_strcmp(str, "hash")) return s2i_ASN1_OCTET_STRING(method, ctx, str);
 
 	if(!(oct = M_ASN1_OCTET_STRING_new())) {
 		X509V3err(X509V3_F_S2I_SKEY_ID,ERR_R_MALLOC_FAILURE);
@@ -142,3 +149,4 @@
 	M_ASN1_OCTET_STRING_free(oct);
 	return NULL;
 }
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_sxnet.c openssl-1.0.0q/crypto/x509v3/v3_sxnet.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_sxnet.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_sxnet.c	2017-04-25 16:23:40.888798434 +0200
@@ -56,12 +56,15 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Support for Thawte strong extranet extension */
 
@@ -69,37 +72,40 @@
 
 static int sxnet_i2r(X509V3_EXT_METHOD *method, SXNET *sx, BIO *out, int indent);
 #ifdef SXNET_TEST
+#ifndef OPERA_SMALL_VERSION
 static SXNET * sxnet_v2i(X509V3_EXT_METHOD *method, X509V3_CTX *ctx,
 						STACK_OF(CONF_VALUE) *nval);
 #endif
-const X509V3_EXT_METHOD v3_sxnet = {
+#endif
+
+CONST_X509V3_EXT_METHOD_item(v3_sxnet,
 NID_sxnet, X509V3_EXT_MULTILINE, ASN1_ITEM_ref(SXNET),
 0,0,0,0,
 0,0,
 0, 
-#ifdef SXNET_TEST
-(X509V3_EXT_V2I)sxnet_v2i,
-#else
-0,
-#endif
+OPERA_V2I_DECLARE((X509V3_EXT_V2I)sxnet_v2i),
 (X509V3_EXT_I2R)sxnet_i2r,
 0,
 NULL
-};
+)
 
-ASN1_SEQUENCE(SXNETID) = {
-	ASN1_SIMPLE(SXNETID, zone, ASN1_INTEGER),
+ASN1_SEQUENCE(SXNETID) 
+	ASN1_SIMPLE(SXNETID, zone, ASN1_INTEGER)
 	ASN1_SIMPLE(SXNETID, user, ASN1_OCTET_STRING)
-} ASN1_SEQUENCE_END(SXNETID)
+ASN1_SEQUENCE_END(SXNETID)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(SXNETID)
+#endif
 
-ASN1_SEQUENCE(SXNET) = {
-	ASN1_SIMPLE(SXNET, version, ASN1_INTEGER),
+ASN1_SEQUENCE(SXNET) 
+	ASN1_SIMPLE(SXNET, version, ASN1_INTEGER)
 	ASN1_SEQUENCE_OF(SXNET, ids, SXNETID)
-} ASN1_SEQUENCE_END(SXNET)
+ASN1_SEQUENCE_END(SXNET)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(SXNET)
+#endif
 
 static int sxnet_i2r(X509V3_EXT_METHOD *method, SXNET *sx, BIO *out,
 	     int indent)
@@ -128,6 +134,7 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 static SXNET * sxnet_v2i(X509V3_EXT_METHOD *method, X509V3_CTX *ctx,
 	     STACK_OF(CONF_VALUE) *nval)
 {
@@ -141,6 +148,7 @@
 	}
 	return sx;
 }
+#endif
 		
 	
 #endif
@@ -149,6 +157,7 @@
 
 /* Add an id given the zone as an ASCII number */
 
+#ifndef OPERA_SMALL_VERSION
 int SXNET_add_id_asc(SXNET **psx, char *zone, char *user,
 	     int userlen)
 {
@@ -159,9 +168,11 @@
 	}
 	return SXNET_add_id_INTEGER(psx, izone, user, userlen);
 }
+#endif
 
 /* Add an id given the zone as an unsigned long */
 
+#ifndef OPERA_SMALL_VERSION
 int SXNET_add_id_ulong(SXNET **psx, unsigned long lzone, char *user,
 	     int userlen)
 {
@@ -174,12 +185,14 @@
 	return SXNET_add_id_INTEGER(psx, izone, user, userlen);
 	
 }
+#endif
 
 /* Add an id given the zone as an ASN1_INTEGER.
  * Note this version uses the passed integer and doesn't make a copy so don't
  * free it up afterwards.
  */
 
+#ifndef OPERA_SMALL_VERSION
 int SXNET_add_id_INTEGER(SXNET **psx, ASN1_INTEGER *zone, char *user,
 	     int userlen)
 {
@@ -189,7 +202,7 @@
 		X509V3err(X509V3_F_SXNET_ADD_ID_INTEGER,X509V3_R_INVALID_NULL_ARGUMENT);
 		return 0;
 	}
-	if(userlen == -1) userlen = strlen(user);
+	if(userlen == -1) userlen = op_strlen(user);
 	if(userlen > 64) {
 		X509V3err(X509V3_F_SXNET_ADD_ID_INTEGER,X509V3_R_USER_TOO_LONG);
 		return 0;
@@ -205,7 +218,7 @@
 	}
 
 	if(!(id = SXNETID_new())) goto err;
-	if(userlen == -1) userlen = strlen(user);
+	if(userlen == -1) userlen = op_strlen(user);
 		
 	if(!M_ASN1_OCTET_STRING_set(id->user, user, userlen)) goto err;
 	if(!sk_SXNETID_push(sx->ids, id)) goto err;
@@ -257,6 +270,7 @@
 	}
 	return NULL;
 }
+#endif
 
 IMPLEMENT_STACK_OF(SXNETID)
 IMPLEMENT_ASN1_SET_OF(SXNETID)
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_utl.c openssl-1.0.0q/crypto/x509v3/v3_utl.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_utl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_utl.c	2017-04-25 16:23:40.889797443 +0200
@@ -58,18 +58,22 @@
 /* X509 v3 extension utilities */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
 #include <openssl/bn.h>
 
 static char *strip_spaces(char *name);
+#ifndef OPERA_SMALL_VERSION
 static int sk_strcmp(const char * const *a, const char * const *b);
 static STACK_OF(OPENSSL_STRING) *get_email(X509_NAME *name, GENERAL_NAMES *gens);
 static void str_free(OPENSSL_STRING str);
 static int append_ia5(STACK_OF(OPENSSL_STRING) **sk, ASN1_IA5STRING *email);
+#endif
 
 static int ipv4_from_asc(unsigned char *v4, const char *in);
 static int ipv6_from_asc(unsigned char *v6, const char *in);
@@ -124,6 +128,7 @@
 	return X509V3_add_value(name, "FALSE", extlist);
 }
 
+#ifndef OPERA_SMALL_VERSION
 int X509V3_add_value_bool_nf(char *name, int asn1_bool,
 						STACK_OF(CONF_VALUE) **extlist)
 {
@@ -143,6 +148,7 @@
 	BN_free(bntmp);
 	return strtmp;
 }
+#endif
 
 char *i2s_ASN1_INTEGER(X509V3_EXT_METHOD *method, ASN1_INTEGER *a)
 {
@@ -214,14 +220,14 @@
 {
 	char *btmp;
 	if(!(btmp = value->value)) goto err;
-	if(!strcmp(btmp, "TRUE") || !strcmp(btmp, "true")
-		 || !strcmp(btmp, "Y") || !strcmp(btmp, "y")
-		|| !strcmp(btmp, "YES") || !strcmp(btmp, "yes")) {
+	if(!op_strcmp(btmp, "TRUE") || !op_strcmp(btmp, "true")
+		 || !op_strcmp(btmp, "Y") || !op_strcmp(btmp, "y")
+		|| !op_strcmp(btmp, "YES") || !op_strcmp(btmp, "yes")) {
 		*asn1_bool = 0xff;
 		return 1;
-	} else if(!strcmp(btmp, "FALSE") || !strcmp(btmp, "false")
-		 || !strcmp(btmp, "N") || !strcmp(btmp, "n")
-		|| !strcmp(btmp, "NO") || !strcmp(btmp, "no")) {
+	} else if(!op_strcmp(btmp, "FALSE") || !op_strcmp(btmp, "false")
+		 || !op_strcmp(btmp, "N") || !op_strcmp(btmp, "n")
+		|| !op_strcmp(btmp, "NO") || !op_strcmp(btmp, "no")) {
 		*asn1_bool = 0;
 		return 1;
 	}
@@ -231,6 +237,7 @@
 	return 0;
 }
 
+#ifndef OPERA_SMALL_VERSION
 int X509V3_get_value_int(CONF_VALUE *value, ASN1_INTEGER **aint)
 {
 	ASN1_INTEGER *itmp;
@@ -241,6 +248,7 @@
 	*aint = itmp;
 	return 1;
 }
+#endif // !OPERA_SMALL_VERSION
 
 #define HDR_NAME	1
 #define HDR_VALUE	2
@@ -344,10 +352,10 @@
 	char *p, *q;
 	/* Skip over leading spaces */
 	p = name;
-	while(*p && isspace((unsigned char)*p)) p++;
+	while(*p && op_isspace((unsigned char)*p)) p++;
 	if(!*p) return NULL;
-	q = p + strlen(p) - 1;
-	while((q != p) && isspace((unsigned char)*q)) q--;
+	q = p + op_strlen(p) - 1;
+	while((q != p) && op_isspace((unsigned char)*q)) q--;
 	if(p != q) q[1] = 0;
 	if(!*p) return NULL;
 	return p;
@@ -365,9 +373,9 @@
 	char *tmp, *q;
 	const unsigned char *p;
 	int i;
-	const static char hexdig[] = "0123456789ABCDEF";
+	const char * const hexdig = "0123456789ABCDEF"; /* ARRAY OK 2008-02-27 haavardm */
 	if(!buffer || !len) return NULL;
-	if(!(tmp = OPENSSL_malloc(len * 3 + 1))) {
+	if(!(tmp = (char *) OPENSSL_malloc(len * 3 + 1))) {
 		X509V3err(X509V3_F_HEX_TO_STRING,ERR_R_MALLOC_FAILURE);
 		return NULL;
 	}
@@ -388,7 +396,6 @@
 /* Give a string of hex digits convert to
  * a buffer
  */
-
 unsigned char *string_to_hex(const char *str, long *len)
 {
 	unsigned char *hexbuf, *q;
@@ -397,7 +404,7 @@
 		X509V3err(X509V3_F_STRING_TO_HEX,X509V3_R_INVALID_NULL_ARGUMENT);
 		return NULL;
 	}
-	if(!(hexbuf = OPENSSL_malloc(strlen(str) >> 1))) goto err;
+	if(!(hexbuf = (unsigned char *) OPENSSL_malloc(op_strlen(str) >> 1))) goto err;
 	for(p = (unsigned char *)str, q = hexbuf; *p;) {
 		ch = *p++;
 #ifdef CHARSET_EBCDIC
@@ -413,8 +420,8 @@
 			OPENSSL_free(hexbuf);
 			return NULL;
 		}
-		if(isupper(ch)) ch = tolower(ch);
-		if(isupper(cl)) cl = tolower(cl);
+		if(op_isupper(ch)) ch = op_tolower(ch);
+		if(op_isupper(cl)) cl = op_tolower(cl);
 
 		if((ch >= '0') && (ch <= '9')) ch -= '0';
 		else if ((ch >= 'a') && (ch <= 'f')) ch -= 'a' - 10;
@@ -451,16 +458,17 @@
 {
 	int len, ret;
 	char c;
-	len = strlen(cmp);
-	if((ret = strncmp(name, cmp, len))) return ret;
+	len = op_strlen(cmp);
+	if((ret = op_strncmp(name, cmp, len))) return ret;
 	c = name[len];
 	if(!c || (c=='.')) return 0;
 	return 1;
 }
 
+#ifndef OPERA_SMALL_VERSION
 static int sk_strcmp(const char * const *a, const char * const *b)
 {
-	return strcmp(*a, *b);
+	return op_strcmp(*a, *b);
 }
 
 STACK_OF(OPENSSL_STRING) *X509_get1_email(X509 *x)
@@ -562,11 +570,14 @@
 	}
 	return 1;
 }
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 void X509_email_free(STACK_OF(OPENSSL_STRING) *sk)
 {
 	sk_OPENSSL_STRING_pop_free(sk, str_free);
 }
+#endif
 
 /* Convert IP addresses both IPv4 and IPv6 into an 
  * OCTET STRING compatible with RFC3280.
@@ -574,7 +585,7 @@
 
 ASN1_OCTET_STRING *a2i_IPADDRESS(const char *ipasc)
 	{
-	unsigned char ipout[16];
+	unsigned char ipout[16]; /* ARRAY OK 2007-11-07 yngve UNUSED */
 	ASN1_OCTET_STRING *ret;
 	int iplen;
 
@@ -599,10 +610,10 @@
 ASN1_OCTET_STRING *a2i_IPADDRESS_NC(const char *ipasc)
 	{
 	ASN1_OCTET_STRING *ret = NULL;
-	unsigned char ipout[32];
+	unsigned char ipout[32]; /* ARRAY OK 2007-11-07 yngve UNUSED*/
 	char *iptmp = NULL, *p;
 	int iplen1, iplen2;
-	p = strchr(ipasc,'/');
+	p = (char*)strchr(ipasc,'/');
 	if (!p)
 		return NULL;
 	iptmp = BUF_strdup(ipasc);
@@ -676,7 +687,7 @@
 
 typedef struct {
 		/* Temporary store for IPV6 output */
-		unsigned char tmp[16];
+		unsigned char tmp[16];  /* ARRAY OK 2007-11-07 yngve UNUSED */
 		/* Total number of bytes in tmp */
 		int total;
 		/* The position of a zero (corresponding to '::') */
@@ -759,7 +770,7 @@
 
 static int ipv6_cb(const char *elem, int len, void *usr)
 	{
-	IPV6_STAT *s = usr;
+	IPV6_STAT *s = (IPV6_STAT *)usr;
 	/* Error if 16 bytes written */
 	if (s->total == 16)
 		return 0;
@@ -826,7 +837,6 @@
 	return 1;
 	}
 
-
 int X509V3_NAME_from_section(X509_NAME *nm, STACK_OF(CONF_VALUE)*dn_sk,
 						unsigned long chtype)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3conf.c openssl-1.0.0q/crypto/x509v3/v3conf.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3conf.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3conf.c	2017-04-25 16:23:40.889797443 +0200
@@ -57,7 +57,9 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/asn1.h>
 #include <openssl/conf.h>
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3err.c openssl-1.0.0q/crypto/x509v3/v3err.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3err.c	2017-04-25 16:23:40.890797291 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/x509v3.h>
 
@@ -68,7 +70,7 @@
 #define ERR_FUNC(func) ERR_PACK(ERR_LIB_X509V3,func,0)
 #define ERR_REASON(reason) ERR_PACK(ERR_LIB_X509V3,0,reason)
 
-static ERR_STRING_DATA X509V3_str_functs[]=
+static const ERR_STRING_DATA X509V3_str_functs[]=
 	{
 {ERR_FUNC(X509V3_F_A2I_GENERAL_NAME),	"A2I_GENERAL_NAME"},
 {ERR_FUNC(X509V3_F_ASIDENTIFIERCHOICE_CANONIZE),	"ASIDENTIFIERCHOICE_CANONIZE"},
@@ -138,7 +140,7 @@
 {0,NULL}
 	};
 
-static ERR_STRING_DATA X509V3_str_reasons[]=
+static const ERR_STRING_DATA X509V3_str_reasons[]=
 	{
 {ERR_REASON(X509V3_R_BAD_IP_ADDRESS)     ,"bad ip address"},
 {ERR_REASON(X509V3_R_BAD_OBJECT)         ,"bad object"},
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3prin.c openssl-1.0.0q/crypto/x509v3/v3prin.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3prin.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3prin.c	2017-04-25 16:23:40.891797418 +0200
@@ -58,7 +58,9 @@
 
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/asn1.h>
 #include <openssl/conf.h>
 #include <openssl/x509.h>
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/x509v3.h openssl-1.0.0q/crypto/x509v3/x509v3.h
--- openssl-1.0.0q.orig/crypto/x509v3/x509v3.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/x509v3.h	2017-04-25 16:23:40.892797266 +0200
@@ -66,6 +66,12 @@
 extern "C" {
 #endif
 
+#if defined OPERA_SMALL_VERSION
+#define OPERA_X509V3_EXT_METHOD_decl extern
+#else
+#define OPERA_X509V3_EXT_METHOD_decl
+#endif
+
 /* Forward reference */
 struct v3_ext_method;
 struct v3_ext_ctx;
@@ -115,9 +121,23 @@
 X509V3_EXT_I2R i2r;
 X509V3_EXT_R2I r2i;
 
-void *usr_data;	/* Any extension specific data */
+const void *usr_data;	/* Any extension specific data */
 };
 
+#ifndef OPERA_SMALL_VERSION
+#define OPERA_V2I_DECLARE(f) f
+#define OPERA_I2S_DECLARE(f) f
+#define OPERA_S2I_DECLARE(f) f
+#define OPERA_R2I_DECLARE(f) f
+#define OPERA_I2R_DECLARE(f) f
+#else
+#define OPERA_V2I_DECLARE(f) NULL
+#define OPERA_I2S_DECLARE(f) NULL
+#define OPERA_S2I_DECLARE(f) NULL
+#define OPERA_R2I_DECLARE(f) NULL
+#define OPERA_I2R_DECLARE(f) NULL
+#endif
+
 typedef struct X509V3_CONF_METHOD_st {
 char * (*get_string)(void *db, char *section, char *value);
 STACK_OF(CONF_VALUE) * (*get_section)(void *db, char *section);
@@ -142,6 +162,45 @@
 
 DECLARE_STACK_OF(X509V3_EXT_METHOD)
 
+#define CONST_X509V3_EXT_METHOD_item(name, _ext_nid, _ext_flags,_it,_ext_new,_ext_free,_d2i,_i2d,_i2s,_s2i,_i2v,_v2i,_i2r,_r2i,_usr_data) \
+	OPENSSL_PREFIX_CONST_ITEM(OPENSSL_EXTERN,X509V3_EXT_METHOD, name, libopeay) \
+	CONST_ITEM_ENTRY_START(ext_nid,_ext_nid)\
+	CONST_ITEM_ENTRY_SINGLE(ext_flags,_ext_flags)\
+	CONST_ITEM_ENTRY_SINGLE(it,_it)\
+	CONST_ITEM_ENTRY_SINGLE(ext_new,_ext_new)\
+	CONST_ITEM_ENTRY_SINGLE(ext_free,_ext_free)\
+	CONST_ITEM_ENTRY_SINGLE(d2i,_d2i)\
+	CONST_ITEM_ENTRY_SINGLE(i2d,_i2d)\
+	CONST_ITEM_ENTRY_SINGLE(i2s,_i2s)\
+	CONST_ITEM_ENTRY_SINGLE(s2i,_s2i)\
+	CONST_ITEM_ENTRY_SINGLE(i2v,_i2v)\
+	CONST_ITEM_ENTRY_SINGLE(v2i,_v2i)\
+	CONST_ITEM_ENTRY_SINGLE(i2r,_i2r)\
+	CONST_ITEM_ENTRY_SINGLE(r2i,_r2i)\
+	CONST_ITEM_ENTRY_SINGLE(usr_data,_usr_data)\
+	CONST_ITEM_ENTRY_END
+
+#define CONST_X509V3_EXT_METHOD_ENTRY(_ext_nid, _ext_flags,_it,_ext_new,_ext_free,_d2i,_i2d,_i2s,_s2i,_i2v,_v2i,_i2r,_r2i,_usr_data) \
+	CONST_ENTRY_START(ext_nid,_ext_nid)\
+	CONST_ENTRY_SINGLE(ext_flags,_ext_flags)\
+	CONST_ENTRY_SINGLE(it,_it)\
+	CONST_ENTRY_SINGLE(ext_new,_ext_new)\
+	CONST_ENTRY_SINGLE(ext_free,_ext_free)\
+	CONST_ENTRY_SINGLE(d2i,_d2i)\
+	CONST_ENTRY_SINGLE(i2d,_i2d)\
+	CONST_ENTRY_SINGLE(i2s,_i2s)\
+	CONST_ENTRY_SINGLE(s2i,_s2i)\
+	CONST_ENTRY_SINGLE(i2v,_i2v)\
+	CONST_ENTRY_SINGLE(v2i,_v2i)\
+	CONST_ENTRY_SINGLE(i2r,_i2r)\
+	CONST_ENTRY_SINGLE(r2i,_r2i)\
+	CONST_ENTRY_SINGLE(usr_data,_usr_data)\
+	CONST_ENTRY_END
+
+
+#define DECLARE_X509V3_EXT_METHOD(name)\
+	DECLARE_MODULE_CONST_ITEM(X509V3_EXT_METHOD, name)
+
 /* ext_flags values */
 #define X509V3_EXT_DYNAMIC	0x1
 #define X509V3_EXT_CTX_DEP	0x2
@@ -379,8 +438,13 @@
 /* onlysomereasons present */
 #define IDP_REASONS	0x40
 
+#ifndef OPERA_SMALL_VERSION
 #define X509V3_conf_err(val) ERR_add_error_data(6, "section:", val->section, \
 ",name:", val->name, ",value:", val->value);
+#else
+#define X509V3_conf_err(val)
+#endif /* OPERA_SMALL_VERSION */
+
 
 #define X509V3_set_ctx_test(ctx) \
 			X509V3_set_ctx(ctx, NULL, NULL, NULL, NULL, CTX_TEST)
@@ -390,18 +454,28 @@
 			0,0,0,0, \
 			0,0, \
 			(X509V3_EXT_I2V)i2v_ASN1_BIT_STRING, \
-			(X509V3_EXT_V2I)v2i_ASN1_BIT_STRING, \
+			OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_ASN1_BIT_STRING), \
 			NULL, NULL, \
 			table}
 
-#define EXT_IA5STRING(nid) { nid, 0, ASN1_ITEM_ref(ASN1_IA5STRING), \
+#define CONST_X509V3_EXT_METHOD_BITSTRING_item(name, nid, table) \
+	CONST_X509V3_EXT_METHOD_item(name, nid, 0, ASN1_ITEM_ref(ASN1_BIT_STRING), \
+			0,0,0,0, \
+			0,0, \
+			(X509V3_EXT_I2V)i2v_ASN1_BIT_STRING, \
+			OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_ASN1_BIT_STRING), \
+			NULL, NULL, \
+			table)
+
+#define EXT_IA5STRING(nid) \
+	CONST_X509V3_EXT_METHOD_ENTRY(nid, 0, ASN1_ITEM_ref(ASN1_IA5STRING), \
 			0,0,0,0, \
 			(X509V3_EXT_I2S)i2s_ASN1_IA5STRING, \
-			(X509V3_EXT_S2I)s2i_ASN1_IA5STRING, \
+			OPERA_S2I_DECLARE((X509V3_EXT_S2I)s2i_ASN1_IA5STRING), \
 			0,0,0,0, \
-			NULL}
+			NULL)
 
-#define EXT_END { -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
+#define EXT_END CONST_X509V3_EXT_METHOD_ENTRY(-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
 
 
 /* X509_PURPOSE stuff */
@@ -461,8 +535,8 @@
 	int flags;
 	int (*check_purpose)(const struct x509_purpose_st *,
 				const X509 *, int);
-	char *name;
-	char *sname;
+	const char *name;
+	const char *sname;
 	void *usr_data;
 } X509_PURPOSE;
 
@@ -670,7 +744,9 @@
 void X509V3_EXT_val_prn(BIO *out, STACK_OF(CONF_VALUE) *val, int indent,
 								 int ml);
 int X509V3_EXT_print(BIO *out, X509_EXTENSION *ext, unsigned long flag, int indent);
+#ifndef OPENSSL_NO_FP_API
 int X509V3_EXT_print_fp(FILE *out, X509_EXTENSION *ext, int flag, int indent);
+#endif
 
 int X509V3_extensions_print(BIO *out, char *title, STACK_OF(X509_EXTENSION) *exts, unsigned long flag, int indent);
 
@@ -686,7 +762,7 @@
 int X509_PURPOSE_get_by_id(int id);
 int X509_PURPOSE_add(int id, int trust, int flags,
 			int (*ck)(const X509_PURPOSE *, const X509 *, int),
-				char *name, char *sname, void *arg);
+				const char *name, const char *sname, void *arg);
 char *X509_PURPOSE_get0_name(X509_PURPOSE *xp);
 char *X509_PURPOSE_get0_sname(X509_PURPOSE *xp);
 int X509_PURPOSE_get_trust(X509_PURPOSE *xp);
